import { select, csv } from 'd3';
import { scatterPlot } from './scatterPlot';

const width = window.innerWidth;
const height = window.innerHeight;

const margin = {
  top: 20,
  right: 40,
  bottom: 70,
  left: 70,
};

const csvUrl = [
  'https://gist.githubusercontent.com/',
  'curran/', // User
  'a08a1080b88344b0c8a7/', // Id of the Gist
  'raw/0e7a9b0a5d22642a06d3d5b9bcbad9890c8ee534/', // commit
  'iris.csv', // File name
].join('');

const parseRow = (d) => {
  d.sepal_length = +d.sepal_length;
  d.sepal_width = +d.sepal_width;
  d.petal_length = +d.petal_length;
  d.petal_width = +d.petal_width;

  return d;
};

const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

const main = async () => {
  const data = await csv(csvUrl);
  console.log(data)
  const data1 = await csv(csvUrl, parseRow);
  console.log(data1)
  let numeric_columns = [];
  for (const col in data[0]) {
    typeof data[0][col] === 'number'
      ? numeric_columns.push(col)
      : null; //continue doesn't seem to work here... 
  }
  
  console.log(numeric_columns)

  let i = 0;

  setInterval(() => {
    const plot = scatterPlot()
      .width(width)
      .height(height)
      .data(data)
      .xValue((d) => d[numeric_columns[i]])
      .xAxisTitle(numeric_columns[i])
      .yValue(
        (d) =>
          d[numeric_columns[numeric_columns.length - 1]]
      )
      .yAxisTitle(
        numeric_columns[numeric_columns.length - 1]
      )
      .margin(margin)
      .radius(5);

    //This breaks the relation.  Is this because "i" is evaluated on call?
    //i = (i + 1) % (columns.length - 1);

    svg.call(plot);

    i = (i + 1) % numeric_columns.length;
  }, 3000);
};

main();
